; TinyBattleSound

.include "wait.asm"

.DSEG
SOUNDTBL_L: .byte 1
SOUNDTBL_H: .byte 1

.CSEG
	

.DEF NREG = R16
.DEF NREG_H = R17
.DEF CONST_SOUND = R18
.DEF PULSECNT = R19
.DEF LP1 = R20
.DEF TBLEND = R21
.DEF TBLLP = R22

.MACRO LDTBL
	ldi XL, LOW(ADDR(@0))
	ldi XH, HIGH(ADDR(@0))
.ENDM

; パルスデータ生成マクロ
#define SGOFF 39
#define PCNT(w, l) INT((l) / (w) + .5)
#define TW(w) INT((w) - 9)
#define NW(w) INT((w) - 9)
#define TD(w, l) TW(w), PCNT(w, l)
#define TD2(w, l) TW(w), 255, TW(w), PCNT(w, (l) - (w) * 255)
#define TD3(w, l) TW(w), 255, TW(w), 255, TW(w), PCNT(w, (l) - (w) * 255 * 2)
#define ND(w, l) NW(w), PCNT(w, l)
#define ND2(w, l) NW(w), 255, NW(w), PCNT(w, (l) - (w) * 255)


	; ==============================================================================
	; サウンド出力
	; ARG サウンド番号 0～7	
	; 破壊: ほぼ全て
	; ==============================================================================
SOUND_PROC:
	cli
	ldi NREG, 0xeb
	;ldi NREG_H, 0
	ldi CONST_SOUND, 1 << PNO_SOUND

	add ARG, ARG
	ldi XL, LOW(ADDR(SOUND_TBL))
	ldi XH, HIGH(ADDR(SOUND_TBL))
	add XL, ARG
	adc XH, ZERO
	ld ZL, X+
	ld ZH, X
	icall
	; 音止める
	cbi PORTB, PNO_SOUND ; ここが SGOFF クロック目になるように
	ret

SOUND_TBL:
	.dw SOUND1, SOUND2, SOUND3, SOUND4, SOUND5, SOUND6, SOUND7, SOUND8, SOUNDX1, SOUNDX2


	; ==============================================================================
	; テーブルデータのサウンド出力
	; SRAM(SOUNDTBL_H:SOUNDTBL_L) テーブルアドレス, SRAM(TBLLP) 繰り返し数, TBLEND テーブル終了アドレス
	; 破壊: X, ARG, TMP, LP1
	; ==============================================================================

TBLSOUND:
	ld TBLLP, X+
	ld TBLEND, X+
	sts SOUNDTBL_L, XL
	sts SOUNDTBL_H, XH

TBLSOUND_LP0:
	mov LP1, TBLLP							; 19
TBLSOUND_LP1:
	lds XL, SOUNDTBL_L						; 20
	lds XH, SOUNDTBL_H						; 21

TBLSOUND_LP2:
	ld ARG, X+								; 22
	ld PULSECNT, X+							; 24
	rcall SUB_TONE26						; 26 *
	cp XL, TBLEND							; 10
	breq TBLSOUND_LOC1						; 11
	WAIT 8									; 12
	rjmp TBLSOUND_LP2						; 20

TBLSOUND_LOC1:
	dec LP1									; 13
	breq TBLSOUND_NEXT						; 14
	WAIT 3									; 15
	rjmp TBLSOUND_LP1						; 18

    ; ボタンが離されてなかったら繰り返し
TBLSOUND_NEXT:
    sbis PINB, PNO_BTNIN					; 16
	rjmp TBLSOUND_LP0						; 17

	WAIT_R SGOFF - 18						; 18


	; ==============================================================================
	; SOUND 1
	; RIFLE
	; ==============================================================================
SOUND1:
	LDTBL SOUND1_TBL						; 16

	ldi ARG, NW(128)						; 18
	ldi PULSECNT, PCNT(128, 19386)			; 19
	rcall SUB_NOISE20						; 20 *

SOUND1_LP1:
	ld ARG, X+								; 15
	ld PULSECNT, X+							; 17
	rcall SUB_TONE19						; 19 *
	cpi XL, LOW(ADDR(SOUND1_TBL_END))		; 10
	breq SOUND1_NEXT						; 11
	WAIT 1									; 12
	rjmp SOUND1_LP1							; 13

    ; ボタンが離されてなかったら繰り返し
SOUND1_NEXT:
	sbis PINB, PNO_BTNIN					; 13
	rjmp SOUND1								; 14

	WAIT_R SGOFF - 15						; 15

SOUND1_TBL:
	.db TD(25, 1088), TD(26, 1088), TD(27, 1088), TD(28, 1088), TD(29, 1088), TD(30, 1088), TD(31, 1088), TD(32, 1088)
	.db TD(33, 1088), TD(34, 1088), TD(35, 1088), TD(36, 1088), TD(37, 1088), TD(38, 1088), TD(39, 1088), TD(40, 1088)
	.db TD(41, 1088), TD(42, 1088), TD(43, 1088), TD(44, 1088), TD(46, 1088), TD(48, 1088), TD(50, 1088), TD(52, 1088)
	.db TD(54, 1088), TD(56, 1088), TD(58, 1088), TD(60, 1088), TD(62, 1088), TD(64, 1088), TD(66, 1088), TD(68, 1088)
SOUND1_TBL_END:


	; ==============================================================================
	; SOUND 2
	; RIFLE(ECHO)
	; ==============================================================================
SOUND2:
	ldi LP1, 2								; 23
SOUND2_LP1:
	LDTBL SOUND2_TBL						; 24

SOUND2_LP2:
	ld ARG, X+								; 26
	ld PULSECNT, X+							; 28
	rcall SUB_NOISE30						; 30 *
	cpi XL, LOW(ADDR(SOUND2_TBL_END))		; 15
	brne SOUND2_LOC1						; 16

	dec LP1									; 17
	breq SOUND2_NEXT						; 18
	WAIT 3									; 19
	rjmp SOUND2_LP1							; 22

SOUND2_LOC1:
	WAIT 6									; 18
	rjmp SOUND2_LP2							; 24

SOUND2_NEXT:
    ; ボタンが離されてなかったら繰り返し
	sbis PINB, PNO_BTNIN					; 20
	rjmp SOUND2								; 21

	WAIT_R SGOFF - 22						; 22

SOUND2_TBL:
	.db ND2(12, 3579), ND2(14, 3579), ND(16, 3579), ND(18, 3579), ND(20, 3579), ND(22, 3579), ND(24, 3579), ND(26, 3579)
	.db ND(28, 3579), ND(30, 3579), ND(32, 3579), ND(34, 3579), ND(36, 3579), ND(38, 3579), ND(40, 3579), ND(42, 3579)
SOUND2_TBL_END:


	; ==============================================================================
	; SOUND 3
	; TV GAME
	; ==============================================================================
SOUND3:
	ldi XL, LOW(ADDR(SOUND3_TBL))
	ldi XH, HIGH(ADDR(SOUND3_TBL))
	rjmp TBLSOUND

SOUND3_TBL:
	.db 2, LOW(ADDR(SOUND3_TBL_END))
	.db TD(71, 1277), TD(77, 1277), TD(83, 1277), TD(89, 1277), TD(95, 1277), TD(101, 1277), TD(107, 1277), TD(113, 1277)
	.db TD(113, 1277), TD(107, 1277), TD(101, 1277), TD(95, 1277), TD(89, 1277), TD(83, 1277), TD(77, 1277), TD(71, 1277)
SOUND3_TBL_END:


	; ==============================================================================
	; SOUND 4
	; DUAL TONE
	; ==============================================================================
SOUND4:
	ldi XL, LOW(ADDR(SOUND4_TBL))
	ldi XH, HIGH(ADDR(SOUND4_TBL))
	rjmp TBLSOUND

SOUND4_TBL:
	.db 4, LOW(ADDR(SOUND4_TBL_END))
	.db TD(70, 4716), TD(91, 4716)
SOUND4_TBL_END:


	; ==============================================================================
	; SOUND 5
	; BOMB 1
	; ==============================================================================
SOUND5:
	ldi XL, LOW(ADDR(SOUND5_TBL))
	ldi XH, HIGH(ADDR(SOUND5_TBL))
	rjmp TBLSOUND

SOUND5_TBL:
	.db 2, LOW(ADDR(SOUND5_TBL_END))
	.db TD3(32, 16891), TD3(33, 16891), TD2(34, 16891), TD2(35, 16891)
SOUND5_TBL_END:


	; ==============================================================================
	; SOUND 6
	; BOMB 2
	; ==============================================================================
SOUND6:
	; ピュ～
	LDTBL SOUND6_TBL						; 20
SOUND6_LP1:
	ld ARG, X+								; 22
	ld PULSECNT, X+ 						; 24
	rcall SUB_TONE26						; 26 *
	cpi XL, LOW(ADDR(SOUND6_TBL_END))		; 10
	breq SOUND6_LOC1						; 11
	WAIT 8									; 12
	rjmp SOUND6_LP1 						; 20
SOUND6_LOC1:

	; ボーン
	ldi LP1, 32 							; 13
	WAIT 4									; 14
SOUND6_LP2:
	ldi ARG, NW(254)						; 18
	ldi PULSECNT, 32						; 19
	rcall SUB_NOISE20						; 20 *
	dec LP1 								; 15
	brne SOUND6_LP2 						; 16

	; ボタンが離されてなかったら繰り返し
SOUND6_NEXT:
	sbis PINB, PNO_BTNIN					; 17
	rjmp SOUND6 							; 18

	WAIT_R SGOFF - 19						; 19

SOUND6_TBL:
	.db TD(32, 8125), TD(33, 8125), TD(34, 8125), TD(35, 8125), TD(36, 8125), TD(37, 8125), TD(38, 8125), TD(39, 8125)
	.db TD(40, 8125), TD(41, 8125), TD(42, 8125), TD(43, 8125), TD(44, 8125), TD(45, 8125), TD(46, 8125), TD(47, 8125)
	.db TD(48, 8125), TD(49, 8125), TD(50, 8125), TD(51, 8125), TD(52, 8125), TD(53, 8125), TD(54, 8125), TD(55, 8125)
	.db TD(56, 8125), TD(57, 8125), TD(59, 8125), TD(61, 8125), TD(63, 8125), TD(65, 8125), TD(67, 8125), TD(69, 8125)
SOUND6_TBL_END:


	; ==============================================================================
	; SOUND 7
	; GUN 1
	; ==============================================================================
SOUND7_NEXT:
    ; ボタンが離されてなかったら繰り返し
	sbic PINB, PNO_BTNIN	; 13
	ret

SOUND7:
	ldi ARG, NW(16)			; 15
	ldi LP1, 2				; 16
SOUND7_LP1:
	; 143 * 6 * 16 = 13728 CLOCK
	ldi XL, 6				; 17
SOUND7_LP2:
	ldi PULSECNT, 143		; 18
	rcall SUB_NOISE19		; 19
	dec XL					; 15
	brne SOUND7_LP2			; 16

	; 音止める
	WAIT SGOFF - 17			; 17
	cbi PORTB, PNO_SOUND	; SGOFF
	WAIT 4605 * 4 + 10		; 0

	dec LP1					; 10
	breq SOUND7_NEXT		; 11
	WAIT 3					; 12
	rjmp SOUND7_LP1			; 15


	; ==============================================================================
	; SOUND 8
	; GUN 2
	; ==============================================================================
SOUND8:
	ldi XL, LOW(ADDR(SOUND8_TBL))
	ldi XH, HIGH(ADDR(SOUND8_TBL))
	rjmp TBLSOUND

SOUND8_TBL:
	.db 4, LOW(ADDR(SOUND8_TBL_END))
	.db TD(32, 511), TD(35, 511), TD(40, 511), TD(45, 511), TD(53, 511), TD(63, 511), TD(79, 511), TD(105, 511)
	.db TD(105, 511), TD(79, 511), TD(63, 511), TD(53, 511), TD(45, 511), TD(40, 511), TD(35, 511), TD(32, 511)
SOUND8_TBL_END:


	; ==============================================================================
	; SOUND X1
	; PAC MAN
	; ==============================================================================
SOUNDX1_NEXT:
    ; ボタンが離されてなかったら繰り返し
	sbic PINB, PNO_BTNIN					; 8
	ret

SOUNDX1:
	ldi LP1, 2								; 10

SOUNDX1_LP1:
	LDTBL SOUNDX1_TBL						; 11

SOUNDX1_LP2:
	; 低音クロック(この rcall 自体が 11クロックウェイトを兼ねる)
	rcall SUB_LOWCLOCK						; 13

	ld ARG, X+								; 24
	ld PULSECNT, X+							; 26
	rcall SUB_TONE28						; 28 *
	cpi XL, LOW(ADDR(SOUNDX1_TBL_END))		; 10
	brne SOUNDX1_LP2						; 11

	WAIT SGOFF - 12							; 12
	cbi PORTB, PNO_SOUND
	WAIT 2061 * 4 + 13						; 0

SOUNDX1_LP3:
	ld PULSECNT, -X							; 13
	ld ARG, -X ; +1 clock					; 15
	rcall SUB_TONE19 ; +1 clock				; 18 *
	cpi XL, LOW(ADDR(SOUNDX1_TBL))			; 10
	brne SOUNDX1_LP3						; 11

	WAIT SGOFF - 12							; 12
	cbi PORTB, PNO_SOUND
	WAIT 2061 * 4	+ 5						; 0

	dec LP1									; 5
	breq SOUNDX1_NEXT						; 6
	WAIT 2									; 7
	rjmp SOUNDX1_LP1						; 9

SOUNDX1_TBL:
	.db TD(92, 514), TD(133, 514), TD(52, 514), TD(41, 514), TD(36, 514)
SOUNDX1_TBL_END:


	; ==============================================================================
	; SOUND X2
	; XEVIOUS Blaster
	; ==============================================================================
SOUNDX2:
	ldi XL, LOW(ADDR(SOUNDX2_TBL))
	ldi XH, HIGH(ADDR(SOUNDX2_TBL))

	; 低音クロック
	rcall SUB_LOWCLOCK

	rjmp TBLSOUND

SOUNDX2_TBL:
	.db 1, LOW(ADDR(SOUNDX2_TBL_END))
	.db TD(29, 1062), TD(26, 1062), TD(25, 1062), TD(29, 688), TD(32, 688), TD(35, 688), TD(38, 688), TD(41, 688)
	.db TD(44, 688), TD(47, 688), TD(50, 688), TD(54, 688), TD(58, 688), TD(63, 688), TD(68, 688), TD(73, 688)
	.db TD(78, 688), TD(84, 688), TD(90, 688), TD(96, 688), TD(103, 688), TD(111, 688), TD(120, 688), TD(130, 688)
	.db TD(140, 688), TD(151, 688), TD(163, 688), TD(178, 688), TD(193, 688), TD(209, 688), TD(222, 688), TD(232, 688)
SOUNDX2_TBL_END:


	; ==============================================================================
	; トーン出力
	; ARG 単位幅	TIMER_H:TIMER_L 発音時間
	; 破壊: TMP, TIMER_H:TIMER_L
	; CLOCK 26 で rcall すること ret完了で CLOCK 10
	; ==============================================================================
TONE_LP1:
	WAIT 16						; 7
SUB_TONE19:
	WAIT 6						; 23
SUB_TONE25:
	WAIT 1						; 29
SUB_TONE26:
	WAIT 2						; 30
SUB_TONE28:
	WAIT 5						; 32
	; ピン出力
	in TMP, PORTB				; 37
	eor TMP, CONST_SOUND		; 38
	out PORTB, TMP				; 39 *

	mov TMP, ARG				; 0
TONE_LP2:
	WAIT 1						; 1
	dec TMP						; 2
	brne TONE_LP2				; 3

	dec PULSECNT				; 4
	brne TONE_LP1				; 5

	ret							; 6
								; 10


	; ==============================================================================
	; ノイズ出力
	; LFSR 9bit TAP 0, 4, inv
	; ARG 単位幅	TIMER_H:TIMER_L 発音時間
	; 破壊: TMP, TIMER_H:TIMER_L
	; CLOCK 30 で rcall すること ret完了で CLOCK 15
	; ==============================================================================
NOISE_LP1:
	WAIT 11						; 12
SUB_NOISE19:
	WAIT 1						; 23
SUB_NOISE20:
	WAIT 10						; 24
SUB_NOISE30:
	WAIT 3						; 34
	; ピン出力
	mov TMP, NREG				; 37
	and TMP, CONST_SOUND		; 38
	out PORTB, TMP				; 39 *

	; ノイズ進める
	ror NREG_H					; 0
	mov NREG_H, NREG			; 1
	ror NREG					; 2
	sbrs NREG_H, 4				; 3
	com NREG_H					; 4

	mov TMP, ARG				; 5
NOISE_LP2:
	WAIT 1						; 6
	dec TMP						; 7
	brne NOISE_LP2				; 8

	dec PULSECNT				; 9
	brne NOISE_LP1				; 10

	ret							; 11
								; 15


.UNDEF NREG
.UNDEF NREG_H
.UNDEF CONST_SOUND
.UNDEF PULSECNT
.UNDEF LP1

