; 時間待ちマクロ

; WAIT 1 CLOCK
.MACRO WAIT1
	nop
.ENDM


; WAIT 2 CLOCK
.MACRO WAIT2
	rjmp LOC1
LOC1:
.ENDM


; WAIT 8 CLOCK
.MACRO WAIT8
	rcall WAIT_RET
.ENDM



	; ==============================================================================
	; クロック待ち
	; rcall から ret 完了まで X * 4 + 11～14 CLOCK
	; rjmp での呼び出しは 2 CLOCK 少ない
	; ==============================================================================
#if 0 ; main に移動
WAIT_4X_14:
WAIT_4X_R12:
	nop
WAIT_4X_13:
WAIT_4X_R11:
	nop
WAIT_4X_12:
WAIT_4X_R10:
	nop
WAIT_4X_11:
WAIT_4X_R9:
	subi TMP, 1		; 4
	sbci TMP2, 0	; 5
	brcc WAIT_4X_11	; 6
WAIT_RET:
	ret				; 7
					; 11
#endif


	; ==============================================================================
	; クロック待ち
	; rcall から ret 完了まで X * 3 + 10～12 CLOCK
	; rjmp での呼び出しは 2 CLOCK 少ない
	; ==============================================================================
#if 0 ; main に移動
WAIT_3X_12:
WAIT_3X_R10:
	nop
WAIT_3X_11:
WAIT_3X_R9:
	nop
WAIT_3X_10:
WAIT_3X_R8:
	subi TMP, 1		; 4
	brcc WAIT_3X_10	; 5
	ret				; 6
					; 10
#endif


; WAIT <CLOCK>
.MACRO WAIT

.IF @0 <= 0
	; 0 CLOCK
.ELIF @0 == 1
	; 1 CLOCK
	WAIT1
.ELIF @0 == 2
	; 2 CLOCK
	WAIT2
LOC2_1:
.ELIF @0 == 3
	; 3 CLOCK
	WAIT2
	WAIT1
.ELIF @0 == 4
	; 4 CLOCK
	WAIT2
	WAIT2
.ELIF @0 == 5
	; 5 CLOCK
	WAIT2
	WAIT2
	WAIT1
.ELIF @0 == 6
	; 6 CLOCK
	WAIT2
	WAIT2
	WAIT2
.ELIF @0 == 7
	; 7 CLOCK
	WAIT2
	WAIT2
	WAIT2
	WAIT1
.ELIF @0 == 8
	; 8 CLOCK
	WAIT8
.ELIF @0 == 9
	; 9 CLOCK
	WAIT8
	WAIT1
.ELIF @0 == 10
	; 10 CLOCK
	WAIT8
	WAIT2
.ELIF @0 == 16
	; 16 CLOCK
	WAIT8
	WAIT8
.ELIF @0 <= 778
; 11～ 778
; 8bit
.IF (@0 - 11) % 3 == 0
	ldi TMP, (@0 - 11) / 3
	rcall WAIT_3X_10
.ELIF (@0 - 12) % 3 == 0
	ldi TMP, (@0 - 12) / 3
	rcall WAIT_3X_11
.ELIF (@0 - 13) % 3 == 0
	ldi TMP, (@0 - 13) / 3
	rcall WAIT_3X_12
.ENDIF
.ELSE
; 16bit
.IF (@0 - 13) % 4 == 0
	ldi TMP, LOW((@0 - 13) / 4)
	ldi TMP2, HIGH((@0 - 13) / 4)
	rcall WAIT_4X_11
.ELIF (@0 - 14) % 4 == 0
	ldi TMP, LOW((@0 - 14) / 4)
	ldi TMP2, HIGH((@0 - 14) / 4)
	rcall WAIT_4X_12
.ELIF (@0 - 15) % 4 == 0
	ldi TMP, LOW((@0 - 15) / 4)
	ldi TMP2, HIGH((@0 - 15) / 4)
	rcall WAIT_4X_13
.ELIF (@0 - 16) % 4 == 0
	ldi TMP, LOW((@0 - 16) / 4)
	ldi TMP2, HIGH((@0 - 16) / 4)
	rcall WAIT_4X_14
.ENDIF
.ENDIF
.ENDM


; 指定クロックで ret を完了させる(9～)
.MACRO WAIT_R
.IF @0 <= 4
	.ERROR "out of range"
.ELIF @0 == 4
	ret
.ELIF @0 < 8
	WAIT @0 - 4
	ret
.ELIF @0 <= 776
; 8bit
.IF (@0 - 9) % 3 == 0
	ldi TMP, (@0 - 9) / 3
	rjmp WAIT_3X_R8
.ELIF (@0 - 10) % 3 == 0
	ldi TMP, (@0 - 10) / 3
	rjmp WAIT_3X_R9
.ELIF (@0 - 11) % 3 == 0
	ldi TMP, (@0 - 11) / 3
	rjmp WAIT_3X_R10
.ENDIF
.ELSE
; 16bit
.IF (@0 - 11) % 4 == 0
	ldi TMP, LOW((@0 - 11) / 4)
	ldi TMP2, HIGH((@0 - 11) / 4)
	rjmp WAIT_4X_R9
.ELIF (@0 - 12) % 4 == 0
	ldi TMP, LOW((@0 - 12) / 4)
	ldi TMP2, HIGH((@0 - 12) / 4)
	rjmp WAIT_4X_R10
.ELIF (@0 - 13) % 4 == 0
	ldi TMP, LOW((@0 - 13) / 4)
	ldi TMP2, HIGH((@0 - 13) / 4)
	rjmp WAIT_4X_R11
.ELIF (@0 - 14) % 4 == 0
	ldi TMP, LOW((@0 - 14) / 4)
	ldi TMP2, HIGH((@0 - 14) / 4)
	rjmp WAIT_4X_R12
.ENDIF
.ENDIF
.ENDM



